unit Titlebtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CommCtrl;

type
  TTitlebtn = class(TComponent)
  private
    drawtitlebtn: Boolean;
    titlebtn: TPoint;
    bmpsource,
    bmpnormal, bmppushed, bmpdisabled: TBitmap;
    Down, prevdown, btnenabled: Boolean;
    btnw, btnh, borderx, bordery,
    fromedgex, fromedgey: integer;
    DefWndProc: TWndMethod;
    BtnAction: TNotifyEvent;
    ownerform: TForm;
    procedure GetWindowMetrics;
    procedure Paintbtn(Down: Boolean);
    procedure CreateBitmaps;
    procedure ForceRefreshTitle(callDefWndProc: Boolean);
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure NewWndProc(var Message: TMessage);
    procedure EnableTitlebtn(value: Boolean);
    procedure ShowTitlebtn(value: Boolean);
  published
    { Published declarations }
    property Action: TNotifyEvent read BtnAction write BtnAction;
    property Enabled: Boolean read btnenabled write EnableTitlebtn;// default true;
    property Visible: Boolean read drawtitlebtn write ShowTitlebtn default false;
  end;

procedure Register;

implementation

{ TTitlebtn }

constructor TTitlebtn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ownerform := AOwner as TForm;
  GetWindowMetrics;
  bmpsource := TBitmap.Create;
  bmpnormal := TBitmap.Create;
  bmppushed := TBitmap.Create;
  bmpdisabled := TBitmap.Create;
  CreateBitmaps;
end;

procedure TTitlebtn.CreateBitmaps;
var
  temp: TBitmap;
begin
  temp := TBitmap.Create;
  bmpsource.Width := 120;
  bmpsource.Height := 100;
  bmpnormal.Width := btnw;
  bmpnormal.Height := btnh;
  bmppushed.Width := btnw;
  bmppushed.Height := btnh;
  temp.Width := 120;
  temp.Height := 100;
  with bmpsource.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Rect(0, 0, 120, 100));
    Brush.Color := clBlack;
    FillRect(Rect(50, 70, 70, 90));
  end;
  with bmpnormal.Canvas do
  begin
    brush.Color := clbtnface;
    FillRect(Rect(0, 0, btnw, btnh));
    Pen.Color := clBtnFace;
    Rectangle(0, 0, btnw, btnh);
    Pen.Color := cl3DDkShadow;
    MoveTo(btnw-1, 0);
    LineTo(btnw-1, btnh-1);
    LineTo(-1, btnh-1);
    Pen.Color := clBtnShadow;
    MoveTo(btnw-2, 1);
    LineTo(btnw-2, btnh-2);
    LineTo(0, btnh-2);
    Pen.Color := clBtnHighLight;
    MoveTo(btnw-2, 0);
    LineTo(0, 0);
    LineTo(0, btnh-1);
    Pen.Color := cl3DLight;
    MoveTo(btnw-3, 1);
    LineTo(1, 1);
    LineTo(1, btnh-2);
    CopyMode := cmSrcAnd;
    temp.Canvas.Brush.Color := clBlack;
    temp.Canvas.FillRect(Rect(0, 0, 120, 100));
    temp.Canvas.Brush.Color := clBtnText;
    temp.Canvas.FillRect(Rect(50, 70, 70, 90));
    StretchDraw(Rect(2, 2, btnw-2, btnh-2), bmpsource);
    CopyMode := cmSrcPaint;
    StretchDraw(Rect(2, 2, btnw-2, btnh-2), temp);
  end;
  with bmppushed.Canvas do
  begin
    brush.Color := clbtnface;
    FillRect(Rect(0, 0, btnw, btnh));
    Pen.Color := clBtnFace;
    Rectangle(0, 0, btnw, btnh);
    Pen.Color := cl3DDkShadow;
    MoveTo(btnw-2, 0);
    LineTo(0, 0);
    LineTo(0, btnh-1);
    Pen.Color := clBtnShadow;
    MoveTo(btnw-3, 1);
    LineTo(1, 1);
    LineTo(1, btnh-2);
    Pen.Color := cl3DLight;
    MoveTo(btnw-2, 1);
    LineTo(btnw-2, btnh-2);
    LineTo(0, btnh-2);
    Pen.Color := clBtnHighLight;
    MoveTo(btnw-1, 0);
    LineTo(btnw-1, btnh-1);
    LineTo(-1, btnh-1);
    CopyMode := cmSrcAnd;
    StretchDraw(Rect(3, 3, btnw-1, btnh-1), bmpsource);
    CopyMode := cmSrcPaint;
    StretchDraw(Rect(2, 2, btnw-2, btnh-2), temp);
  end;
  with bmpdisabled.Canvas do
  begin
    temp.Canvas.Brush.Color := clBlack;
    temp.Canvas.FillRect(Rect(0, 0, 120, 100));
    temp.Canvas.Brush.Color := clBtnHighLight;
    temp.Canvas.FillRect(Rect(50, 70, 70, 90));
    bmpdisabled.Assign(bmpnormal);
    CopyMode := cmSrcAnd;
    StretchDraw(Rect(3, 3, btnw-1, btnh-1), bmpsource);
    CopyMode := cmSrcPaint;
    StretchDraw(Rect(3, 3, btnw-1, btnh-1), temp);
    temp.Canvas.Brush.Color := clBtnShadow;
    temp.Canvas.FillRect(Rect(50, 70, 70, 90));
    CopyMode := cmSrcAnd;
    StretchDraw(Rect(2, 2, btnw-2, btnh-2), bmpsource);
    CopyMode := cmSrcPaint;
    StretchDraw(Rect(2, 2, btnw-2, btnh-2), temp);
  end;
  temp.Free;
end;

destructor TTitlebtn.Destroy;
begin
  ShowTitlebtn(false);
  bmpsource.Free;
  bmpnormal.Free;
  bmppushed.Free;
  bmpdisabled.Free;
  inherited Destroy;
end;

procedure TTitlebtn.EnableTitlebtn(value: Boolean);
begin
  btnenabled := value;
  Down := false;
  ForceRefreshTitle(false);
end;

procedure TTitlebtn.ForceRefreshTitle(callDefWndProc: Boolean);
var
  newmes: TMessage;
  hrgn: integer;
begin
  newmes.Msg := WM_NCPAINT;
  hrgn := CreateRectRgn(ownerform.Left, ownerform.top, ownerform.Left+ownerform.Width, ownerform.Top+fromedgey+btnh+6);
  newmes.WParam := hrgn;
  if callDefWndProc = true then
    DefWndProc(newmes)
  else
    ownerform.WindowProc(newmes);
  DeleteObject(hrgn);
end;

procedure TTitlebtn.GetWindowMetrics;
begin
  if ownerform.BorderStyle = bsSizeable then
  begin
    borderx := GetSystemMetrics(SM_CXSIZEFRAME);
    bordery := GetSystemMetrics(SM_CYSIZEFRAME);
    btnw := GetSystemMetrics(SM_CXSIZE) - 2;
    btnh := GetSystemMetrics(SM_CYSIZE) - 4;
    fromedgex := btnw * 4 + 6 + borderx;
    fromedgey := 2 + bordery;
  end
  else if ownerform.BorderStyle = bsDialog then
  begin
    borderx := GetSystemMetrics(SM_CXFIXEDFRAME);
    bordery := GetSystemMetrics(SM_CYFIXEDFRAME);
    btnw := GetSystemMetrics(SM_CXSIZE) - 2;
    btnh := GetSystemMetrics(SM_CYSIZE) - 4;
    fromedgex := btnw * 2 + 4 + borderx;
    fromedgey := 2 + bordery;
  end
  else if ownerform.BorderStyle = bsSingle then
  begin
    borderx := GetSystemMetrics(SM_CXFIXEDFRAME);
    bordery := GetSystemMetrics(SM_CYFIXEDFRAME);
    btnw := GetSystemMetrics(SM_CXSIZE) - 2;
    btnh := GetSystemMetrics(SM_CYSIZE) - 4;
    fromedgex := btnw * 4 + 6 + borderx;
    fromedgey := 2 + bordery;
  end;
end;

procedure TTitlebtn.NewWndProc(var Message: TMessage);
begin
  if message.Msg = WM_NCHITTEST then
    if (message.LParamLo-ownerform.Left < titlebtn.x) or (message.LParamHi-ownerform.Top < titlebtn.y) or
      (message.LParamLo-ownerform.Left >= titlebtn.x+btnw) or (message.LParamHi-ownerform.Top >= titlebtn.y+btnh) then
    begin
      if prevdown = true then
      begin
        prevdown := false;
        Paintbtn(false);
      end;
    end
    else if prevdown <> Down then
    begin
      prevdown := Down;
      Paintbtn(Down);
    end;
  if (message.LParamLo-ownerform.Left >= titlebtn.x) and (message.LParamHi-ownerform.Top >= titlebtn.y) and
    (message.LParamLo-ownerform.Left < titlebtn.x+btnw) and (message.LParamHi-ownerform.Top < titlebtn.y+btnh) then
  begin
    if message.Msg = WM_NCLBUTTONDOWN then
    begin
      ownerform.Show;
      if btnenabled = true then
        Down := true;
      exit;
    end
    else if message.Msg = WM_NCLBUTTONUP then
    begin
      Down := false;
      if btnenabled = true then
        if Assigned(BtnAction) then
          BtnAction(self);
      exit;
    end
    else if message.Msg = WM_NCRBUTTONDOWN then
    begin
      ownerform.Show;
      exit;
    end
    else if message.Msg = WM_NCLBUTTONDBLCLK then
    begin
      ownerform.Show;
      exit;
    end;
  end
  else if (message.Msg = WM_NCLBUTTONUP) or (message.Msg = WM_LBUTTONUP) then
    Down := false;
  DefWndProc(Message);
  if (message.Msg = WM_NCPAINT) or (message.Msg = WM_NCACTIVATE) or (message.Msg = WM_SIZE) then
  begin
    ForceRefreshTitle(true);
    ownerform.Repaint;
    Down := false;
    Paintbtn(false);
  end;
end;

procedure TTitlebtn.Paintbtn(Down: Boolean);
var
  hdc,
  imageindex: integer;
begin
  if btnenabled = true then
    imageindex := ord(Down)
  else
    imageindex := 2;
  hdc := GetWindowDC(ownerform.handle);
  titlebtn.x := ownerform.Width - fromedgex;
  titlebtn.y := fromedgey;
  case imageindex of
    0: DrawState(hdc, 0, nil, bmpnormal.Handle, 0, titlebtn.x, titlebtn.y, 0, 0, DST_BITMAP + DSS_NORMAL);
    1: DrawState(hdc, 0, nil, bmppushed.Handle, 0, titlebtn.x, titlebtn.y, 0, 0, DST_BITMAP + DSS_NORMAL);
    2: DrawState(hdc, 0, nil, bmpdisabled.Handle, 0, titlebtn.x, titlebtn.y, 0, 0, DST_BITMAP + DSS_NORMAL);
  end;
  ReleaseDC(ownerform.handle, hdc);
end;

procedure TTitlebtn.ShowTitlebtn(value: Boolean);
var
  i: integer;
  comnum: integer;
begin
  comnum := 0;
  if owner = nil then exit;
  for i := 0 to owner.ComponentCount - 1 do
    if owner.Components[i].ClassName = 'TTitlebtn' then
      comnum := comnum + 1;
  if comnum > 1 then exit;
  if (ownerform.BorderStyle = bsSizeable) or
     (ownerform.BorderStyle = bsDialog) or
     (ownerform.BorderStyle = bsSingle) then
  begin
    if drawtitlebtn <> value then
    begin
      drawtitlebtn := value;
      if drawtitlebtn = true then
      begin
        DefWndProc := ownerform.WindowProc;
        ownerform.WindowProc := NewWndProc;
        Down := false;
        prevdown := false;
      end
      else if Assigned(DefWndProc) then
        ownerform.WindowProc := DefWndProc;
    end;
    ownerform.Repaint;
    ForceRefreshTitle(false);
  end;
end;

procedure Register;
begin
  RegisterComponents('Standard', [TTitlebtn]);
end;

end.
